﻿unit Jpfix.Main;

interface

procedure Register;

implementation

uses
  Winapi.Windows, System.SysUtils, Jpfix.Core;

type
  TCallHookInfo = record
    BaseFuncName: string;
    OriginalValue: Pointer;
    Offset: Integer;
    ReplaceFunc: Pointer;
    HookPtr: Pointer;
    Hooked: Boolean;
  end;

var
  CallHookInfo: array[0..1] of TCallHookInfo = (
    (
      BaseFuncName: {$IFDEF VER250}'@Editorcontrol@TCustomEditControl@MouseMove$qqr61System@%Set$t32System@Classes@System_Classes__1$iuc$0$iuc$10%ii';{$ENDIF} // XE4
                    {$IFDEF VER260}'@Editorcontrol@TCustomEditControl@MouseMove$qqr61System@%Set$t32System@Classes@System_Classes__1$iuc$0$iuc$10%ii';{$ENDIF} // XE5
                    {$IFDEF VER270}'@Editorcontrol@TCustomEditControl@MouseMove$qqr61System@%Set$t32System@Classes@System_Classes__1$iuc$0$iuc$10%ii';{$ENDIF} // XE6
                    {$IFDEF VER280}'@Editorcontrol@TCustomEditControl@MouseMove$qqr60System@%Set$32System@Classes@System_Classes__1t1$i0$t1$i10$%ii';{$ENDIF} // XE7
                    {$IFDEF VER290}'@Editorcontrol@TCustomEditControl@MouseMove$qqr60System@%Set$32System@Classes@System_Classes__1uc$i0$uc$i10$%ii';{$ENDIF} // XE8
                    {$IFDEF VER300}'@Editorcontrol@TCustomEditControl@MouseMove$qqr60System@%Set$32System@Classes@System_Classes__1t1$i0$t1$i10$%ii';{$ENDIF} // 10 Seattle
      Offset: $E5;
      ReplaceFunc: @MyColFromX;
      HookPtr: nil;
      Hooked: False;
    ),
    (
      BaseFuncName: '@Idepopuplistbox@TIDEPopupListBox@ShowList$qqrx20System@UnicodeString';
      Offset: $1E;
      ReplaceFunc: @MyGetCaretPixelX;
      HookPtr: nil;
      Hooked: False;
    )
  );

procedure Register;

  function CallHookProc(Target: Pointer; ReplaceProc: Pointer): Pointer;
  var
    oldProtect: Cardinal;
  begin
    Result := PPointer(Target)^;
    VirtualProtect(Target, SizeOf(Pointer), PAGE_READWRITE, oldProtect);
    PInteger(Target)^ := Integer(ReplaceProc) - (Integer(Target) + SizeOf(Pointer));
    VirtualProtect(Target, SizeOf(Pointer), oldProtect, oldProtect);
    FlushInstructionCache(GetCurrentProcess, Target, SizeOf(Pointer));
  end;

var
  hModule: THandle;
  i: Integer;
  p: PByte;
begin
  hModule := GetModuleHandle(sCoreideName);

  for i := Low(CallHookInfo) to High(CallHookInfo) do
  begin
    p := GetProcAddress(hModule, PChar(CallHookInfo[i].BaseFuncName));

    if p = nil then
      raise Exception.Create('初期化に失敗しました');
    if PByte(p + CallHookInfo[i].Offset)^ <> $E8 then
      raise Exception.Create('初期化に失敗しました');

    CallHookInfo[i].HookPtr := p + CallHookInfo[i].Offset + 1{opsize};
    CallHookInfo[i].OriginalValue := CallHookProc(CallHookInfo[i].HookPtr, CallHookInfo[i].ReplaceFunc);
    CallHookInfo[i].Hooked := True;
  end;
end;

procedure Unregister;

  procedure UnhookProc(Target: Pointer; const OrgCodes; Count: Integer);
  var
    oldProtect: Cardinal;
  begin
    VirtualProtect(Target, Count, PAGE_READWRITE, oldProtect);
    Move(OrgCodes, Target^, Count);
    VirtualProtect(Target, Count, oldProtect, oldProtect);
    FlushInstructionCache(GetCurrentProcess, Target, Count);
  end;

var
  i: Integer;
begin
  for i := Low(CallHookInfo) to High(CallHookInfo) do
  begin
    if not CallHookInfo[i].Hooked then Continue;
    UnhookProc(CallHookInfo[i].HookPtr, CallHookInfo[i].OriginalValue, SizeOf(CallHookInfo[i].OriginalValue));
  end;
end;

initialization
finalization
  Unregister;
end.
